# Create custom object records Creates custom object records with the given type. Upon creating records of a custom object type, the 200 response contains a list of records that have been successfully processed and stored. ### Limitations This call has the following limitations: * The maximum number of records that you can create by one call is 1,000. * The storage of empty strings in records is not supported. * Null values must be formatted as the following example: { "records": [ { "fieldName__c": null } ] } * When creating or updating custom object records with relationship-type fields, Zuora verifies the related objects against the transactional databases, which are updated in near real-time. The record creation or modification fails upon unsuccessful verifications. If the related objects are newly created in your tenant, it might need some time for the transactional database synchronization. Endpoint: POST /objects/records/default/{object} Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) API version that determines the response schema. The default version is used if this parameter is not included. Specify Zuora-Version in the request header if you expect a specific response schema. ## Path parameters: - `object` (string, required) Specifies the custom object's API name as object. It is case-sensitive. ## Request fields (application/json): - `allowPartialSuccess` (boolean) Indicates whether the records that pass the schema validation should be created when not all records in the request pass the schema validation. Example: true - `records` (array, required) A list of custom object records to be created Example: [{"DeviceId__c":"10101011"}] ## Response 200 fields (application/json): - `error` (object) - `error.code` (integer) Example: "710125XX" - `error.details` (array) Example: [{"code":"710125XX","message":"Field [age__c] is an integer field but received a string value.","record":{"Id":"8a19f16a-2b5e-4a26-bb20-c79cd6984714","age__c":"32","email__c":"smith123@example.com","home_address__c":"59b38ad1-27d4-40e8-af66-8c138bc382ee","last_name__c":"Smith","marital_status__c":"Married","work_address__c":"8a19f16a-2b5e-4a26-bb20-c79cd6984714"}}] - `error.details.code` (integer) See Custom Objects API error code for details. Enum: 71012520, 71012521, 71012522, 71012523, 71012524, 71012525, 71012526, 71012530 - `error.details.message` (string) Example: "Field [last_name__c] cannot accept empty string." - `error.details.record` (object) Record data from an object Example: {"DeviceId__c":"10101011"} - `error.details.record.CreatedById` (string) The creator's Id - `error.details.record.CreatedDate` (string) The record creation time in the date-time format - `error.details.record.Id` (string) The unique Id of the custom object record - `error.details.record.UpdatedById` (string) The modifier's Id - `error.details.record.UpdatedDate` (string) The record modification time in the date-time format - `error.details.record.type` (string) The type of the custom object record. It is the API name of the custom object definition. - `records` (array) The custom object records that are succesfully created and stored Example: [{"DeviceId__c":"10101011"}] ## Response 400 fields (application/json): - `code` (integer) Example: "710125XX" - `details` (array) Example: [{"code":"710125XX","message":"Field [age__c] is an integer field but received a string value.","record":{"Id":"8a19f16a-2b5e-4a26-bb20-c79cd6984714","age__c":"32","email__c":"smith123@example.com","home_address__c":"59b38ad1-27d4-40e8-af66-8c138bc382ee","last_name__c":"Smith","marital_status__c":"Married","work_address__c":"8a19f16a-2b5e-4a26-bb20-c79cd6984714"}}] - `details.code` (integer) See Custom Objects API error code for details. Enum: 71012520, 71012521, 71012522, 71012523, 71012524, 71012525, 71012526, 71012530 - `details.message` (string) Example: "Field [last_name__c] cannot accept empty string." - `details.record` (object) Record data from an object Example: {"DeviceId__c":"10101011"} - `details.record.CreatedById` (string) The creator's Id - `details.record.CreatedDate` (string) The record creation time in the date-time format - `details.record.Id` (string) The unique Id of the custom object record - `details.record.UpdatedById` (string) The modifier's Id - `details.record.UpdatedDate` (string) The record modification time in the date-time format - `details.record.type` (string) The type of the custom object record. It is the API name of the custom object definition. ## Response 401 fields (application/json): - `code` (integer) Example: "7101251X" - `details` (array) Example: [{"code":"7101251X","message":"Unauthorized to view object record."}] - `details.message` (string) Example: "Unauthorized Action" ## Response 500 fields (application/json): - `code` (integer) Example: 71012561 - `details` (array) Example: [{"code":71012561,"message":"Unable to process record due to internal error or database throttling.","record":{"Id":"8a19f16a-2b5e-4a26-bb20-c79cd6984714","age__c":32,"email__c":"smith123@example.com","home_address__c":"59b38ad1-27d4-40e8-af66-8c138bc382ee","last_name__c":"Smith","marital_status__c":"Married","work_address__c":"8a19f16a-2b5e-4a26-bb20-c79cd6984714"}}] - `details.code` (integer) See Custom Objects API error code for details. Enum: 71012520, 71012521, 71012522, 71012523, 71012524, 71012525, 71012526, 71012530 - `details.message` (string) Example: "Field [last_name__c] cannot accept empty string." - `details.record` (object) Record data from an object Example: {"DeviceId__c":"10101011"} - `details.record.CreatedById` (string) The creator's Id - `details.record.CreatedDate` (string) The record creation time in the date-time format - `details.record.Id` (string) The unique Id of the custom object record - `details.record.UpdatedById` (string) The modifier's Id - `details.record.UpdatedDate` (string) The record modification time in the date-time format - `details.record.type` (string) The type of the custom object record. It is the API name of the custom object definition.